# This script can be used to automatically check the assignments of students
import py
import os
import sys
import argparse
verbose = True

# List of assignment names and achievable points
test_list = [("simplestring",   2),
             ("circle",         2),
             ("flexcircle",     3),
             ("ranking",        3),
            ]
max_points = sum([x[1] for x in test_list])


def run_test(name):
    test_file = "test_" + name + ".py"
    if not os.path.isfile(test_file):
        print "Test file '{0}' does not exist.".format(test_file)
        exit(1)
    if verbose:
        return py.test.cmdline.main(["-s", test_file])
    else:
        return py.test.cmdline.main(["-q", test_file])

def run_all_tests():
    summary = ""
    point_list = []

    for test, points in test_list:
        print "*"*20 + " testing {0} ".format(test) + "*"*20
        exit_code = run_test(test)
        if exit_code == 0:
            print "Test {0} passed ({1} points)\n".format(test, points)
            summary += "Test {0} passed ({1} points)\n".format(test, points)
            point_list.append(points)
        else:
            print "Test {0} failed (0 points)\n".format(test)
            summary += "Test {0} failed (0 points)\n".format(test)

    total_points = sum(point_list)
    summary += "Rough (!!) estimate of points: {0} / {1}".format(total_points, max_points)
    return summary, point_list

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description='Tests assignemnts.')
    parser.add_argument('-s', '--silent', action='store_false',
                        help='Surpress most output')
    args = parser.parse_args()
    verbose = args.silent

    summary = run_all_tests()[0]
    print "== Summary ==\n", summary
